(in-package cl)
(defpackage optparser-tests (:use :optparser :cl :ptester))
(in-package optparser-tests)

(defmacro test-mv (values form)
	`(test ,values ,form :multiple-values t :test #'equal))

(defun do-tests ()
  (with-tests (:name "OPTPARSER")
    (let ((*break-on-test-failures* nil))

      ;; parse-argv
			(test-mv '(() ()) (parse-argv () ()))
			(test-mv '(("arg1" "arg2") ()) (parse-argv '("arg1" "arg2") ()))
			(test-mv '(() ((1))) (parse-argv () '(("v" :value nil :idx 1))))

			(test-mv
				'(("enc" "path1" "path2")
					(("timeout" . 10) ("t" . 10) ("timeout" . "20") (2 . t) (:conc . "10") (1 . t)))
				(parse-argv '("enc" "-vc" "10" "--logging" "path1" "--timeout=20" "path2")
					'(("v" :value nil :idx 1) ("verbose" :value nil :idx 1)
						("l" :value nil :idx 2) ("logging" :value nil :idx 2) ("log-to" :value t :idx 2)
						("c" :value t :idx :conc) ("concurrency" :value t :idx :conc)
						("t" :value 10) ("timeout" :value 10))))

			(test-mv
				'(("enc" "path")
					(("timeout" . 10) ("t" . 10) (:conc . t) (2) (1)))
				(parse-argv '("enc" "path")
					'(("v" :value nil :idx 1) ("verbose" :value nil :idx 1)
						("l" :value nil :idx 2) ("logging" :value nil :idx 2) ("log-to" :value t :idx 2)
						("c" :value t :idx :conc) ("concurrency" :value t :idx :conc)
						("t" :value 10) ("timeout" :value 10))))


      ;; public macroz
			(test '(nil t 1)
				(with-argv (argz a b c)
					(()
						("v" "verbose" "debug")
						("itm" :value t)
						("val" :value 1)
						("none" :value nil))
					(list a b c)) :test #'equal)

			(test '(t "-val" 1 nil)
				(with-argv (argz a b c d)
					(("arg" "--verbose" "-vi" "-val")
						("v" "verbose" "debug")
						("i" "itm" :value t)
						("v" "val" :value 1)
						("none" :value nil))
					(list a b c d)) :test #'equal)
      ))
  t)
